unit fmn;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, activex, OoMisc, AdPort, AdWnPort;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ClientSocket1: TClientSocket;
    ComPort1: TApdWinsockPort;
    procedure Button1Click(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);

    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  private
    { Private declarations }
  public
    procedure feldolgozas;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

function PCSLibVer: integer; stdcall; external 'PCSLib.Dll';

function PCSCoder(bejon: pChar; behossz: integer;  kimegy: pChar;
                  var kihossz: Integer;  FeladoCim: Integer; CelCim: Integer;
                  CsomagID :Integer;  nyugta_info :Integer; KuldoPort :Integer;
                  FogadoPort :Integer): TBSTr; stdcall; external 'PCSLib.dll';

function PCSDecoder(bejon: pChar;       behossz: integer;
                   kimegy: pChar;  var kihossz: Integer;
                   var FeladoCim: Integer; var CelCim: Integer;
                   var CsomagID :Integer;  var nyugta_info :Integer;
                   var KuldoPort :Integer; var FogadoPort :Integer;
                   var Sikerult: Integer): TBSTr; stdcall; external 'PCSLib.dll';


{$R *.dfm}


var inbuf : string;

function TBStr2String( be: TBStr ): String;
var Kiad: String;
    i: Integer;
    pc: PChar;
begin
   Kiad:='';
   pc:=Pointer(be);
   for i:=1 to SysStringByteLen(be) do begin
     Kiad:=Kiad+pc^;
     pc:=pc+1;
   end;
   SysFreeString( be );
   Result:=Kiad;
end;


procedure TForm1.Button1Click(Sender: TObject);
var kipufhossz:integer;
    fogadom:string;
    i:integer;
begin
  kipufhossz:=0;

  //252-es szm megjelentse a kijelzn
  fogadom:= TBStr2String(pcscODER('CLCSH252',8,nil,kipufhossz,0,1,0,0,0,0));
  for i:= 1 to length(fogadom) do begin
     ClientSocket1.Socket.SendText(fogadom[i]);
  end;
  
  // gy lehet soro portra kldeni
  Comport1.PutString(fogadom);
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var i:integer;
begin
    inbuf := inbuf + ClientSocket1.Socket.ReceiveText;
    Feldolgozas;
end;

procedure TForm1.Feldolgozas;
var kihossz:integer;
    ki:string;
    nk:integer;
begin
  kihossz:=256;
  ki:=StringOfChar(' ',256);
  PCSDeCoder(pchar(inbuf),Length(inbuf),pchar(ki),kihossz,nk,nk,nk,nk,nk,nk,nk);
  ki:=Copy(ki,1,kihossz);
  ShowMessage('Ki: '+ki);
  inbuf := '';
end;

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
var ErrorCode: Integer);
begin
  ErrorCode :=0;
end;

end.


